with GAda.Text_IO ;
with INSA_Air;
with Train;
with Avion_Sol;
with Assert;
with Carburant;
with Pilote_Automatique;
with Tour;
with Cartographie;
with GAda.Integer_Text_IO;
procedure Mission4 is

   package Int renames GAda.Integer_Text_IO;
   --
   -- Mission 2, partie 1 : fonction Delta_Cap
   --
   -- Cette fonction Delta_Cap est incorrecte.
   -- À vous de corriger son algorithme.
   --
   function Delta_Cap(Cap_Actuel : Float ; Cap_Voulu : Float) return Float is
      Ecart_Angle : Float ;
      
   begin
      Ecart_Angle := Cap_Voulu - Cap_Actuel ;

      if Ecart_Angle < -180.0 then
         Ecart_Angle := Ecart_Angle + 360.0 ;
      end if ;
      if Ecart_Angle > 180.0 then
	 Ecart_Angle := Ecart_Angle -360.0;
      end if;

      return Ecart_Angle ;
   end Delta_Cap ;

   
   --
   -- Mission 2, partie 1 : procédure de test de Delta_Cap
   -- 
   -- Cette procédure est incomplète, à vous de la rendre utile.
   --
   procedure Tester_Delta_Cap(CapA : Float ; CapV : Float) is
      Ecart_Angle: Float;
   begin
      Ecart_Angle := Delta_Cap(Cap_Actuel => CapA, Cap_Voulu => CapV);
      GAda.Text_IO.Put_Line (Aff => "Le cap actuel vaut" & Float'Image(CapA) & " Le cap Voulut vaut:" & Float'Image(CapV) & " Delta Cap vaut:" & Float'Image(Ecart_Angle)) ;
   end Tester_Delta_Cap ;
   
   --
   -- Mission 2, partie 2 : fonction Caps_Egaux
   function Caps_Egaux(Cap1:Float; Cap2:Float) return Boolean is
      Dif_Cap: Float;
   begin
      Dif_Cap:= abs((Delta_Cap(Cap1 , Cap2)));
      return Dif_Cap <= 5.0;
   end Caps_Egaux;
   
   
   --
   -- Mission 2, partie 2 : procédure de test de Caps_Egaux
   procedure Tester_Caps_Egaux(Cap1: Float; Cap2: Float) is
      Rep: Boolean;
   begin
      Rep := Caps_Egaux(Cap1 , Cap2);
      GAda.Text_IO.Put_Line(Aff => "Ecart:" & Boolean'Image(Rep));
   end Tester_Caps_Egaux;
   
   --
   -- Mission 2, parties 1 et 2 : réalisation de plusieurs tests
   --
   procedure Tests_Unitaires is
   begin
      Tester_Delta_Cap (CapA => 0.0,   CapV => 45.0) ;
      Tester_Delta_Cap (CapA => 45.0,  CapV => 0.0) ;
      Tester_Delta_Cap (CapA => 350.0, CapV => 10.0) ;
      Tester_Delta_Cap (CapA => 10.0,  CapV => 350.0) ;
      Tester_Delta_Cap (CapA => 30.0,  CapV => 285.0) ;
      Tester_Delta_Cap (CapA => 178.0,  CapV => 182.0) ;
      Tester_Caps_Egaux(Cap1 => 0.0,   Cap2 => 5.0) ;
      Tester_Caps_Egaux(Cap1 => 2.0,  Cap2 => 359.0) ;
      Tester_Caps_Egaux(Cap1 => 350.0, Cap2 => 10.0) ;
      Tester_Caps_Egaux(Cap1 => 10.0,  Cap2 => 350.0) ;
      Tester_Caps_Egaux(Cap1 => 178.0,  Cap2 => 182.0) ;
      
      -- Ajouter vos propres tests unitaires
   end Tests_Unitaires ;
   

   --
   -- Mission 2, partie 3 : procédure Orienter_au_sol
   procedure Orienter_Au_Sol(Cap: Float) is
      Cap_Bon: Boolean;
      Delt_Cap: Float;
   begin
      Cap_Bon:= (Cap < 0.0) or (Cap > 360.0);
      Assert.Failif(Cap_Bon , "Le cap demandé ne correspond pas aux attentes");
      INSA_Air.Regler_Reacteur(1);
      while not Caps_Egaux(Cap , INSA_Air.Cap_Courant) loop
	 Delt_Cap:= Delta_Cap(INSA_Air.Cap_Courant , Cap);
	 if Delt_Cap <0.0 then
	    Train.Positionner_A_Gauche;
	 elsif Delt_Cap = 0.0 then
	    Train.Positionner_A_Zero;
	 else
	    Train.Positionner_A_Droite;
	 end if;
	 INSA_Air.Attendre(0.05);
      end loop;
      Avion_Sol.Freiner;
   end Orienter_Au_Sol;
   
   
   --
   
   
   --
   -- Mission 2, partie 3 : procédure Tester_Cap
   --
   procedure Tester_Cap is
   begin
      Avion_Sol.Rouler_Vers('L');
      Avion_Sol.Rouler_Vers('M');
      Avion_Sol.Freiner;
      Avion_Sol.Attendre_Entree;
      Mission4.Orienter_Au_Sol(0.0);
      Avion_Sol.Attendre_Entree;
      Mission4.Orienter_Au_Sol(90.0);
      Avion_Sol.Attendre_Entree;
      Mission4.Orienter_Au_Sol(270.0);
      Avion_Sol.Attendre_Entree;
      Mission4.Orienter_Au_Sol(180.0);
      Avion_Sol.Attendre_Entree;
      Avion_Sol.Rouler_Vers('L');
      Avion_Sol.Rouler_Vers('K');
      
   end Tester_Cap;
   --
   -- Mission 2, partie 4 : procédure Orienter_en_vol
   --
   procedure Orienter_En_Vol(Cap: Float) is
      Cap_Bon: Boolean;
      Delt_Cap: Float;
   begin
      Cap_Bon:= (Cap < 0.0) or (Cap > 360.0);
      Assert.Failif(Cap_Bon , "Le cap demandé ne correspond pas aux attentes");
      while not Caps_Egaux(Cap , INSA_Air.Cap_Courant) loop
	 Delt_Cap:= Delta_Cap(INSA_Air.Cap_Courant , Cap);
	 if Delt_Cap <0.0 then
	    INSA_Air.Positionner_Gouverne_A_Gauche;
	 elsif Delt_Cap = 0.0 then
	    INSA_Air.Positionner_Gouverne_A_Zero;
	 else
	    INSA_Air.Positionner_Gouverne_A_Droite;
	 end if;
	 
      end loop;
      INSA_Air.Positionner_Gouverne_A_Zero;
   end Orienter_En_Vol;
   
   --
   -- Mission 2, partie 4 : procédure Realiser_Vol_Demo
   --
   procedure Realiser_Vol_Demo is
   begin
      Carburant.Faire_Le_Plein;
      Tour.Attendre_Autorisation_Roulage;
      Avion_Sol.Rouler_Vers('L');
      Avion_Sol.Rouler_Vers('M');
      Avion_Sol.Rouler_Vers('E');
      Avion_Sol.Rouler_Vers('A');
      Tour.Attendre_Autorisation_Decollage;
      INSA_Air.Regler_Reacteur(8);
      Pilote_Automatique.Decoller;
      INSA_Air.Regler_Reacteur(6);
      Train.Deplacer_Train(FALSE);
      Mission4.Orienter_En_Vol(295.0);
      INSA_Air.Attendre(1200.0);
      Mission4.Orienter_En_Vol(115.0);
      INSA_Air.Attendre(900.0);
      INSA_Air.Regler_Reacteur(3);
      Train.Deplacer_Train(True);
      Tour.Attendre_Autorisation_Atterrissage;
      Pilote_Automatique.Atterrir;
      Avion_Sol.Rouler_Vers('N');
      Avion_Sol.Rouler_Vers('M');
      Avion_Sol.Rouler_Vers('L');
      Avion_Sol.Rouler_Vers('K');
   end Realiser_Vol_Demo;
   
   procedure Info_Aeroport(CodeA:String) is
   begin
      GAda.Text_IO.Put_Line( Aff=> Cartographie.Nom_Aeroport(Code => CodeA));
      GAda.Text_IO.Put_Line(Float'Image(Cartographie.Coords_Aeroport(Code => CodeA).Long) & Float'Image(Cartographie.Coords_Aeroport(Code => CodeA).Lat));
   end Info_Aeroport;
   
   procedure Tester_Carto is
   begin
      GAda.Text_IO.Put_Line( Aff=> Cartographie.Nom_Aeroport(Code => "LFBO"));
      GAda.Text_IO.Put_Line(Float'Image(Cartographie.Coords_Aeroport(Code => "LFBO").Long) & Float'Image(Cartographie.Coords_Aeroport(Code => "LFBO").Lat));
      GAda.Text_IO.Put_Line( Aff=> Cartographie.Nom_Aeroport(Code => "EGLL"));
      GAda.Text_IO.Put_Line(Float'Image(Cartographie.Coords_Aeroport(Code => "EGLL").Long) & Float'Image(Cartographie.Coords_Aeroport(Code => "EGLL").Lat));
      GAda.Text_IO.Put_Line( Aff=> Cartographie.Nom_Aeroport(Code =>"LFPG"));
      GAda.Text_IO.Put_Line(Float'Image(Cartographie.Coords_Aeroport(Code => "LFPG").Long) & Float'Image(Cartographie.Coords_Aeroport(Code => "LFPG").Lat));
   end Tester_Carto;
   
   function Distance(P1: Cartographie.T_Coords; P2: Cartographie.T_Coords) return Float is
      Dist: Float;
   begin
      Dist := Cartographie.SQRT((P2.Long - P1.Long)**2 + (P2.Lat - P1.Lat)**2)*111.600;
      return Dist;
   end Distance;
   
   function Cap_Cible(Code: String) return Float is
      Vecteur_X: Float;
      Vecteur_Y:Float;
   begin
      Vecteur_X:= (Cartographie.Coords_Aeroport(Code).Long - Cartographie.Coords_Avion.Long);
      Vecteur_Y:= (Cartographie.Coords_Aeroport(Code).Lat - Cartographie.Coords_Avion.Lat);
      return Cartographie.Cap_Vecteur(Vecteur_X , Vecteur_Y);
   end Cap_Cible;
   
   function Aeroport_Proche return Integer is
      Aeroport_Max: Integer;
      Aeroport_Test: Integer;
      Aeroport_Proche: Integer;
   begin
      Aeroport_Max:= Cartographie.Nb_Aeroports;
      Aeroport_Test:=1;
      Aeroport_Proche:= 1;
      while Aeroport_Test <= Aeroport_Max loop
	 if (Distance(Cartographie.Coords_Avion, Cartographie.Coords_Aeroport(Cartographie.Code_Aeroport(Aeroport_Test))) < Distance(Cartographie.Coords_Avion, Cartographie.Coords_Aeroport(Cartographie.Code_Aeroport(Aeroport_Proche)))) then 
	    Aeroport_Proche := Aeroport_Test;
	 end if;
	 Aeroport_Test:= Aeroport_Test+1;
      end loop;
      return Aeroport_Proche;
   end Aeroport_Proche;
   
   function Naviguer_Vers(Code: String) return Float is
      Dist_Max: Float := 0.0;
      Aeroport_Max: Integer:= 1;
   begin
      while Distance(Cartographie.Coords_Avion, Cartographie.Coords_Aeroport(Code)) >= 100.0 loop
	 Orienter_En_Vol(Cap_Cible(Code));
	 Cartographie.Placer_Marque(Cartographie.Coords_Aeroport(Cartographie.Code_Aeroport(Aeroport_Proche)));
	 if Distance(Cartographie.Coords_Avion, Cartographie.Coords_Aeroport(Cartographie.Code_Aeroport(Aeroport_Proche))) > Dist_Max then
	    Dist_Max := Distance(Cartographie.Coords_Avion, Cartographie.Coords_Aeroport(Cartographie.Code_Aeroport(Aeroport_Proche)));
	    Aeroport_Max := Aeroport_Proche;
	 end if;

      end loop;
      return Dist_Max;
   end Naviguer_Vers;
   
   procedure Liste is
      Nb : Integer;
      Nb_Actuel: Integer := 1;
   begin
      Nb := Cartographie.Nb_Aeroports;
      while Nb > Nb_Actuel loop
	 GAda.Text_IO.Put_Line(Cartographie.Nom_Aeroport(Cartographie.Code_Aeroport(Nb_Actuel)) & " " & Integer'Image(Nb_Actuel));
	 Nb_Actuel := Nb_Actuel +1;
      end loop;
   end Liste;
   
   procedure Voyage is
      Destination: Integer;
      Dist_Test: Float; 
      Dist_Max_Totale: Float := 0.0;
   begin
      Destination := Int.FGet;
      while (Destination < 0) or (Destination > 0) loop
	 if Destination <= Cartographie.Nb_Aeroports then
	 Dist_Test := Naviguer_Vers(Cartographie.Code_Aeroport(Destination));
	  if Dist_Test > Dist_Max_Totale then
	     Dist_Max_Totale := Dist_Test;
	  end if;
	else
	    GAda.Text_IO.Put_Line("Numéro d'aéroport invalide");
	 end if;
	 Destination := Int.FGet;
      end loop;
      Dist_Test := Naviguer_Vers("LFBO");
      if Dist_Test > Dist_Max_Totale then
	 Dist_Max_Totale := Dist_Test;
      end if;
      GAda.Text_IO.Put_Line("Durant ce voyage, l'avion a toujours été à moins de " & Float'Image(Dist_Max_Totale) & " km d'un aéroport");
   end Voyage;
   
   
   


begin
   
   -- Effectuer tous les tests unitaires de Delta_Cap et Caps_Egaux
   Liste;
   Info_Aeroport("LFBD");
   Tester_Carto;
   GAda.Text_IO.Put_Line(Float'Image(Distance( P1 => Cartographie.Coords_Aeroport("LFBO"), P2 => Cartographie.Coords_Aeroport("EGLL"))));
   GAda.Text_IO.Put_Line(Float'Image(Cap_Cible("EGLL")));
   Carburant.Faire_Le_Plein;
   Tour.Attendre_Autorisation_Roulage;
   Avion_Sol.Rouler_Vers('L');
   Avion_Sol.Rouler_Vers('M');
   Avion_Sol.Rouler_Vers('E');
   Avion_Sol.Rouler_Vers('A');
   Tour.Attendre_Autorisation_Decollage;
   INSA_Air.Regler_Reacteur(8);
   Pilote_Automatique.Decoller;
   INSA_Air.Regler_Reacteur(6);
   Train.Deplacer_Train(FALSE);
   Voyage;
   
   INSA_Air.Regler_Reacteur(3);
   Train.Deplacer_Train(True);
   Tour.Attendre_Autorisation_Atterrissage;
   Pilote_Automatique.Atterrir;
   Avion_Sol.Rouler_Vers('N');
   Avion_Sol.Rouler_Vers('M');
   Avion_Sol.Rouler_Vers('L');
   Avion_Sol.Rouler_Vers('K');

end mission4 ;
